depozit/depozit/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf.urls import url
from django.contrib.auth import views




urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('my_app.urls')),
    path('login/', views.LoginView.as_view(), name='login'),
    path('logout/', views.LogoutView.as_view(next_page='/'), name='logout'),
    url('', include('django_prometheus.urls')),
]

depozit/my_app/urls.py
from django.contrib import admin
from django.urls import path
from my_app import views
from django.conf import settings
from django.conf.urls.static import static


app_name='my_app'
urlpatterns = [
    path('', views.index, name='index'),
    path('first_page/', views.first_page, name='first_page'),
    path('sign_up', views.sign_up, name='sign_up'),
    path('products/', views.products, name='products'),
    path('products/<int:pk>', views.product, name='product'),
    path('products/<int:pk>/update', views.ProductUpdateView.as_view(), name='update_product'),
    path('products/<int:pk>/delete', views.delete_product, name='delete_product'),
    path('categorys/', views.categorys, name='categorys'),
    path('categorys/<str:pk>', views.products_of_category, name='products_of_category'),
    path('categorys/<str:pk>/add_product/', views.add_product, name='add_product'),
    path('add_category/', views.add_category, name='add_category'),
    path('account', views.account, name='account'),
    # path('add_user', views.add_user, name='add_user'),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

depozit/my_app/models.py
from email.policy import default
from django.db import models
from django.contrib.auth.models import Group, User
from django.urls import reverse
from django_prometheus.models import ExportModelOperationsMixin
from mptt.models import MPTTModel, TreeForeignKey
from django.db.models.signals import post_save
from django.dispatch import receiver
from PIL import Image


class UserProfile(models.Model):
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    avatar = models.ImageField(upload_to='profile_pic')
    def __str__(self):
        return self.user


class Profile(models.Model):
    user = models.OneToOneField(User, on_delete=models.CASCADE)
    first_name = models.CharField(max_length=100, blank=True)
    last_name = models.CharField(max_length=100, blank=True)
    email = models.EmailField(max_length=150)
    avatar = models.ImageField(default='default.png', upload_to='profile_pic')

    def __str__(self):
        return self.user.username
    # Override the save method of the model
    def save(self, *args, **kwargs):
        super(Profile, self).save(*args, **kwargs)

        img = Image.open(self.avatar.path) # Open avatar
        
        # resize avatar
        if img.height > 300 or img.width > 300:
            output_size = (300, 300)
            img.thumbnail(output_size) # Resize avatar
            img.save(self.avatar.path) # Save it again and override the larger avatar

@receiver(post_save, sender=User)
def update_profile_signal(sender, instance, created, **kwargs):
    if created:
        Profile.objects.create(user=instance)
    instance.profile.save()

class Category(MPTTModel):
    __metaclass__ = ExportModelOperationsMixin
    user = models.ForeignKey(User, on_delete=models.CASCADE, default=None)
    group = models.ForeignKey(Group, on_delete=models.CASCADE, default=None)
    parent = TreeForeignKey('self', on_delete=models.CASCADE, null=True, blank=True, related_name='children')
    name = models.CharField(max_length=200)
    class MPTTMeta:
        order_insertion_by = ['name']
    def __str__(self):
        return self.name

class Product( models.Model):
    __metaclass__ = ExportModelOperationsMixin
    name = models.CharField(max_length=70)
    price = models.IntegerField()
    description = models.TextField(max_length=200)
    category = models.ForeignKey(Category, on_delete=models.CASCADE, default=None)
    product_pic = models.ImageField(upload_to='product_pic', blank=True, default=None)
    items = models.PositiveIntegerField(default=0)
    def __str__(self):                      
        return self.name
    def get_absolute_url(self):
        return reverse("my_app:product", kwargs={'pk':self.pk})

depozit/my_app/forms.py
from django import forms
from django.forms import fields
from my_app.models import Product, Category, UserProfile
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth.models import User
#from phonenumber_field.formfields import PhoneNumberField


class ProductForm(forms.ModelForm):
    
    class Meta():
        model = Product
        fields = ('name', 'price', 'description', 'items', 'product_pic')

class CategoryForm(forms.ModelForm):
    class Meta():
        model = Category
        fields = ('name', 'parent')

class RegisterForm(UserCreationForm):
    email = forms.EmailField()
    # phone = PhoneNumberField()

    class Meta():
        model = User
        User.is_superuser=False
        fields = ('username', 'email', 'password1', 'password2')
    
    # def save(self, commit=True):
    #     user = super(RegisterForm, self).save(commit=False)
    #     user.email = self.cleaned_data["email"]
    #     user.phone = self.cleaned_data["phone"]
    #     if commit:
    #         user.save()
    #     return user
class UserProfileForm(forms.ModelForm):
    class Meta:
        model = UserProfile
        fields = ('user','avatar')

    def clean_avatar(self):
        avatar = self.cleaned_data['avatar']
        return avatar

class SignUpForm(UserCreationForm):
    first_name = forms.CharField(max_length=100, help_text='Last Name')
    last_name = forms.CharField(max_length=100, help_text='Last Name')
    email = forms.EmailField(max_length=150, help_text='Email')
    avatar = forms.ImageField(required=False)


    class Meta:
        model = User
        fields = ('username', 'first_name', 'last_name', 'email', 'password1', 'password2', 'avatar')

depozit/my_app/views.py
from my_app.models import Category, Product
from django.shortcuts import redirect, render
from my_app.forms import CategoryForm, ProductForm, RegisterForm, SignUpForm
from django.contrib.auth import login, authenticate
from django.contrib.auth.decorators import login_required
from django.shortcuts import get_object_or_404, render
from django.views.generic import UpdateView
from django.urls import reverse_lazy, reverse
from django.contrib.auth.mixins import LoginRequiredMixin
from my_app import metrics
import logging
from django.contrib import messages
import threading
import sweetify
from django.http import HttpResponse
from django.views.decorators.clickjacking import xframe_options_deny
from django.views.decorators.clickjacking import xframe_options_sameorigin
from django.contrib.auth.models import Group


thread1 = threading.Thread(target= metrics.monitorize, daemon=True)
thread1.start()


logger = logging.getLogger('my_app.views')

logger.info('Depozit Started!')

def index(request):
    if request.user.is_authenticated:
        a = Group.objects.raw("select * from auth_user_groups aug where user_id = " + str(request.user.id) + ";")
        for i in a:
            request.session['group_id'] = i.group_id
    return render(request, "index.html")

@login_required
def first_page(request):
    if request.user.is_authenticated:
        a = Group.objects.raw("select * from auth_user_groups aug where user_id = " + str(request.user.id) + ";")
        for i in a:
            request.session['group_id'] = i.group_id
    return render(request, "first_page.html")

@login_required
def add_product(request, pk):
    if request.method == 'POST':
        product_form = ProductForm(data = request.POST)
        if product_form.is_valid():
            product = product_form.save(commit=False)
            if 'product_pic' in request.FILES:
                product.product_pic = request.FILES['product_pic']
            product.category = get_object_or_404(Category, pk = pk)
            product.save()
            metrics.product_added.inc()
            logger.info(f'Succesfully Added Product: ')
            sweetify.success(request, f'Successfully added product {product.name}!', position='top-right', timer=2000)
            return redirect(reverse('my_app:products_of_category', args=[product.category.id]))
        else:
            sweetify.error(request, title='Oops...', icon= 'error', text= 'Something went wrong!', footer= "<a href='{%url 'my_app:index'%}'>Why do I have this issue?</a>", persistent='Ok')
            logger.error(product_form.errors)
    else:
        product_form = ProductForm()
    return render(request, 'add_product.html', {'product_form' : product_form})

def sign_up(request):
    if request.method == 'POST':
        form = SignUpForm(data = request.POST)
        if form.is_valid():
            user = form.save()
            user.refresh_from_db()
            user.profile.first_name = form.cleaned_data.get('first_name')
            user.profile.last_name = form.cleaned_data.get('last_name')
            user.profile.email = form.cleaned_data.get('email')
            if 'avatar' in request.FILES:
                    user.profile.avatar = request.FILES['avatar']
            user.save()
            username = form.cleaned_data.get('username')
            password = form.cleaned_data.get('password1')
            user = authenticate(username=username, password=password)
            login(request, user)
            Group.objects.get_or_create(name=username)
            group = Group.objects.get(name=username) 
            group.user_set.add(user)
            logger.info(f'New group:{group.id}')
            sweetify.success(request, f'Welcome {username}!', position='top-right', timer=1500)
            return redirect('my_app:index')
        else:
            logger.error(form.errors)
    else:
        form = SignUpForm()
    return render(request, 'sign_up.html', {'form': form})

@login_required
def delete_product(request, pk):
    try:
        product = get_object_or_404(Product, pk = pk)
        product.delete()
        return redirect(reverse('my_app:products_of_category', args=[product.category.id]))
    except:
        logger.error(f"The product with pk = {pk} , is not valid!")
    return render(request, 'products.html')


def products(request):
    products = Category.objects.raw("SELECT p.* FROM my_app_product p inner join "\
      "my_app_subcategory s on s.id=p.subcategory_id inner join my_app_category c " \
      "on s.category_id = c.id where s.id = 1 and c.user_id = " + str(request.user.id) + ";")
    print()
    return render(request, 'products.html', {'products' : products})

@login_required
def product(request, pk):
    product = get_object_or_404(Product, pk = pk)
    return render(request, 'product.html', {'product' : product})

@login_required
def categorys(request):
    users_group = Group.objects.raw("SELECT * from auth_user_groups WHERE group_id = " + str(request.session['group_id']) + ";")
    tmp = []
    for i in users_group:
        tmp.append(i.user_id)
    category = Category.objects.filter(user__id__in=tmp)
    return render(request, "categorys.html", {'categorys': category})


@login_required
def products_of_category(request, pk):
    group_id = str(request.session['group_id'])
    users_group = Group.objects.raw("SELECT * from auth_user_groups WHERE group_id = " + group_id + ";")
    tmp = []
    for i in users_group:
        tmp.append(i.user_id)
    category = Category.objects.filter(user__id__in=tmp)
    
    products_of_category = Product.objects.raw("SELECT DISTINCT p.* FROM my_app_product p "\
    "inner join my_app_category c on c.id = p.category_id "\
    "INNER JOIN auth_user_groups aug on c.group_id = aug.group_id "\
    "where c.id =" + str(pk) + "  and aug.group_id =" + group_id + ";")
    return render(request, 'products_of_category.html', 
    {
      'products_of_category':products_of_category,
      'categorys': category,
      'current_category': pk,
    })

@login_required
def add_category(request):
    if request.method == 'POST':
        category_form = CategoryForm(data = request.POST)
        if category_form.is_valid():
            category = category_form.save(commit=False)
            category.user = request.user
            category.group = Group.objects.get(id = request.session['group_id'])
            category.save()
            logger.info(f'Succesfully Added Category: ')
            return redirect(reverse('my_app:categorys'))
        else:
            logger.error("Category invalid; " + category_form.errors)
    else:
        logger.error("Bad HTTP request, should be POST!")
        category_form = CategoryForm()
    return render(request, "add_category.html", {'category_form':category_form})

class ProductUpdateView(LoginRequiredMixin,UpdateView):
    login_url = '/login/'
    redirect_field_name = 'product.html'
    template_name = "product_update.html"
    template_name_suffix = '_update'
    form_class = ProductForm

    model = Product

@xframe_options_sameorigin
@login_required
def account(request, super_user = None):
    #user = request.user
    #form2 = UserProfile()
    if request.method == "POST":
        form = RegisterForm(data = request.POST)
        #form2 = UserProfile(data = request.POST)
        if form.is_valid():
            form.save()
            username = form.cleaned_data.get('username')
            password = form.cleaned_data.get('password1')
            user = authenticate(username=username, password=password)
            if super_user is None:
                group = Group.objects.get(name=request.user.username) 
                group.user_set.add(user)
            else:
                group = Group.objects.get(name=super_user) 
                group.user_set.add(user)
            return redirect('my_app:index')
        else:
            logger.error("Category invalid; " + str(form.errors))
    else:
        form = RegisterForm()

    return render(request, "account.html", {"form":form})

# @login_required
# def account(request):
#     return render(request, "account.html")

depozit/my_app/templates/my_app/add_category.html
{% extends 'base.html' %}
{% block content %}
{% load static %}
{% load crispy_forms_tags %}
<div style="margin: 120px 0 200px 120px;">
    <h3 class="mr-auto row mb-4">Add Category</h3>
    <form method="POST">{%csrf_token%}
        <div class="row">
            <div class="col-md-6">
                <div class="form-group">
                        {{category_form.name | as_crispy_field}}
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-md-6">
                <div class="form-group">
                        {{category_form.parent | as_crispy_field}}
                </div>
            </div>
        </div>
        <input type="submit" value="Add Category" class="btn btn-primary">
    </form>
</div>
{% endblock %}

depozit/my_app/templates/my_app/base.html
<!DOCTYPE html>
<html lang="en">
{% load static %}
{% load crispy_forms_tags %}

<head>
    <title>Blog Project</title>

    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <!-- <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css"> -->
    <link href='https://unpkg.com/boxicons@2.0.7/css/boxicons.min.css' rel='stylesheet'>
    <!-- fade in/out/left -->
    <link href="https://unpkg.com/aos@2.3.1/dist/aos.css" rel="stylesheet">
    <script src="https://unpkg.com/aos@2.3.1/dist/aos.js"></script>

    <!-- Fonts -->
    <link rel="preconnect" href="https://fonts.googleapis.com">
    <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
    <link href="https://fonts.googleapis.com/css2?family=Outfit:wght@300;400&display=swap" rel="stylesheet">

    <!-- SweetAlert2 -->
    <script src="//cdn.jsdelivr.net/npm/sweetalert2@11"></script>


    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js"></script>

    <title>Heta</title>

    <!-- Primary Meta Tags -->
    <meta name="title" content="Play - Free Open Source HTML Bootstrap Template by UIdeck">
    <meta name="description" content="Play - Free Open Source HTML Bootstrap Template by UIdeck Team">
    <!-- ===== All CSS files ===== -->
    <link rel="stylesheet" href="{% static 'css/bootstrap.min.css' %}" />
    <link rel="stylesheet" href="{% static 'css/animate.css' %}" />
    <link rel="stylesheet" href="{% static 'css/lineicons.css' %}" />
    <link rel="stylesheet" href="{% static 'css/ud-styles.css' %}" />
    <link rel="stylesheet" href="{% static 'css/style.css' %}">
    <link rel="stylesheet" href="{% static 'css/sidebar.css' %}">

</head>
<body style="background-color: #EDF6FE;">
    <!-- ====== Header Start ====== -->
  <header class="ud-header" style="background-color: #437FC7;">
          <nav class="navbar navbar-expand-lg">

            <a class="navbar-brand" href="{%url 'my_app:index'%}">
              <img src="{%static 'img/logo.png' %}" alt="Logo" class="logo-image" />
            </a>
            <div class="navbar-collapse">
              <ul id="nav" class="navbar-nav mx-auto">
                <li class="nav-item">
                  <a class="nav-link" href="{%url 'my_app:first_page'%}">Home</a>
                </li>
                {% if user.is_authenticated%}
                <li class="nav-item">
                  <a class="nav-link" href="{%url 'my_app:categorys'%}">Categorys</a>
                </li>
                {%endif%}
                <li class="nav-item">
                  <a class="nav-link" href="#about">About</a>
                </li>
                <li class="nav-item">
                  <a class="nav-link" href="#contact">Contact</a>
                </li>

              </ul>
            </div>
            <div class="navbar-btn d-none d-sm-inline-block">
              {% if user.is_authenticated%}
                <a class="navbar-brand" href="{%url 'my_app:account'%}">
                  <img src="{{user.profile.avatar.url}}" alt="Logo" class="account_image" />
                </a>
                <a class="ud-main-btn ud-white-btn" href="{%url 'logout' %}">
                  Logout
                </a>

              {%else%}
              <a href="{%url 'login'%}" class="ud-main-btn ud-login-btn">
                Sign In
              </a>
              <a class="ud-main-btn ud-white-btn" href="{%url 'my_app:sign_up'%}">
                Sign Up
              </a>
              {%endif%}

            </div>
          </nav>
  </header>

<div style="margin-top: 100px;">
{%block content%}
{%endblock%}
</div>

     <!-- ====== Footer Start ====== -->
     <footer class="ud-footer wow fadeInUp" data-wow-delay=".05s" style="padding-bottom: 50px;">
      <!-- <div class="shape shape-1">
        <img src="assets/images/footer/shape-1.svg" alt="shape" />
      </div>
      <div class="shape shape-2">
        <img src="assets/images/footer/shape-2.svg" alt="shape" />
      </div>
      <div class="shape shape-3">
        <img src="assets/images/footer/shape-3.svg" alt="shape" />
      </div> -->
      <div class="ud-footer-widgets">
        <div class="container">
          <div class="row">
            <div class="col-xl-3 col-lg-4 col-md-6">
              <div class="ud-widget">
                <a href="index.html" class="ud-footer-logo">
                  <img src="{%static 'img/logo.png' %}" alt="logo" />
                </a>
                <p class="ud-widget-desc">
                  We create digital experiences for brands and companies by
                  using technology.
                </p>
                <ul class="ud-widget-socials">
                  <li>
                    <a href="https://twitter.com/MusharofChy">
                      <i class="lni lni-facebook-filled"></i>
                    </a>
                  </li>
                  <li>
                    <a href="https://twitter.com/MusharofChy">
                      <i class="lni lni-twitter-filled"></i>
                    </a>
                  </li>
                  <li>
                    <a href="https://twitter.com/MusharofChy">
                      <i class="lni lni-instagram-filled"></i>
                    </a>
                  </li>
                  <li>
                    <a href="https://twitter.com/MusharofChy">
                      <i class="lni lni-linkedin-original"></i>
                    </a>
                  </li>
                </ul>
              </div>
            </div>

            <div class="col-xl-2 col-lg-2 col-md-6 col-sm-6">
              <div class="ud-widget">
                <h5 class="ud-widget-title">About Us</h5>
                <ul class="ud-widget-links">
                  <li>
                    <a href="javascript:void(0)">Home</a>
                  </li>
                  <li>
                    <a href="javascript:void(0)">Features</a>
                  </li>
                  <li>
                    <a href="javascript:void(0)">About</a>
                  </li>
                  <li>
                    <a href="javascript:void(0)">Testimonial</a>
                  </li>
                </ul>
              </div>
            </div>
            <div class="col-xl-2 col-lg-3 col-md-6 col-sm-6">
              <div class="ud-widget">
                <h5 class="ud-widget-title">Features</h5>
                <ul class="ud-widget-links">
                  <li>
                    <a href="javascript:void(0)">How it works</a>
                  </li>
                  <li>
                    <a href="javascript:void(0)">Privacy policy</a>
                  </li>
                  <li>
                    <a href="javascript:void(0)">Terms of service</a>
                  </li>
                  <li>
                    <a href="javascript:void(0)">Refund policy</a>
                  </li>
                </ul>
              </div>
            </div>
            <div class="col-xl-2 col-lg-3 col-md-6 col-sm-6">
              <div class="ud-widget">
                <h5 class="ud-widget-title">Our Products</h5>
                <ul class="ud-widget-links">
                  <li>
                    <a
                      href="https://lineicons.com/"
                      rel="nofollow noopner"
                      target="_blank"
                      >Lineicons
                    </a>
                  </li>
                  <li>
                    <a
                      href="https://ecommercehtml.com/"
                      rel="nofollow noopner"
                      target="_blank"
                      >Ecommerce HTML</a
                    >
                  </li>
                  <li>
                    <a
                      href="https://ayroui.com/"
                      rel="nofollow noopner"
                      target="_blank"
                      >Ayro UI</a
                    >
                  </li>
                  <li>
                    <a
                      href="https://graygrids.com/"
                      rel="nofollow noopner"
                      target="_blank"
                      >Plain Admin</a
                    >
                  </li>
                </ul>
              </div>
            </div>
          </div>
        </div>
      </div>
      <div class="ud-footer-bottom">
        <!-- <div class="container">
          <div class="row">
            <div class="col-md-8">
              <ul class="ud-footer-bottom-left">
                <li>
                  <a href="javascript:void(0)">Privacy policy</a>
                </li>
                <li>
                  <a href="javascript:void(0)">Support policy</a>
                </li>
                <li>
                  <a href="javascript:void(0)">Terms of service</a>
                </li>
              </ul>
            </div>
            <div class="col-md-4">
              <p class="ud-footer-bottom-right">
                Designed and Developed by
                <a href="https://uideck.com" rel="nofollow">UIdeck</a>
              </p>
            </div>
          </div>
        </div> -->
      </div>
    </footer>
    <!-- ====== Footer End ====== -->

<script type="text/javascript" src="{% static 'js/index.js' %}"></script>

<!-- ====== Back To Top Start ====== -->
<a href="javascript:void(0)" class="back-to-top">
  <i class="lni lni-chevron-up"> </i>
</a>
<!-- ====== Back To Top End ====== -->

<!-- ====== All Javascript Files ====== -->
<script src="{% static 'js/bootstrap.bundle.min.js' %}"></script>
<script src="{% static 'js/wow.min.js' %}"></script>
<script src="{% static 'js/main.js' %}"></script>
<script>
  // ==== for menu scroll
  const pageLink = document.querySelectorAll(".ud-menu-scroll");

  pageLink.forEach((elem) => {
    elem.addEventListener("click", (e) => {
      e.preventDefault();
      document.querySelector(elem.getAttribute("href")).scrollIntoView({
        behavior: "smooth",
        offsetTop: 1 - 60,
      });
    });
  });

  // section menu active
  function onScroll(event) {
    const sections = document.querySelectorAll(".ud-menu-scroll");
    const scrollPos =
      window.pageYOffset ||
      document.documentElement.scrollTop ||
      document.body.scrollTop;

    for (let i = 0; i < sections.length; i++) {
      const currLink = sections[i];
      const val = currLink.getAttribute("href");
      const refElement = document.querySelector(val);
      const scrollTopMinus = scrollPos + 73;
      if (
        refElement.offsetTop <= scrollTopMinus &&
        refElement.offsetTop + refElement.offsetHeight > scrollTopMinus
      ) {
        document
          .querySelector(".ud-menu-scroll")
          .classList.remove("active");
        currLink.classList.add("active");
      } else {
        currLink.classList.remove("active");
      }
    }
  }

  window.document.addEventListener("scroll", onScroll);
</script>
<script>
  AOS.init();
</script>
{% load sweetify %}
{% sweetify %}
</body>
</html>

depozit/my_app/templates/my_app/product.html
{% extends 'base.html' %}
{% block content %}
<style>
body > p { font-size: 32px }

.delete { cursor: pointer; color: #00A }
.isDeleted { text-decoration:line-through }
</style>
<script src="https://code.jquery.com/jquery-2.1.3.min.js"></script>
<script src="https://unpkg.com/sweetalert/dist/sweetalert.min.js"></script>
<link rel="stylesheet" href="http://t4t5.github.io/sweetalert/dist/sweetalert.css">

<link href="https://fonts.googleapis.com/css?family=Bentham|Playfair+Display|Raleway:400,500|Suranna|Trocchi" rel="stylesheet">
<div class="wrapper">
    <div class="product-img">
      <img src="{{ product.product_pic.url }}" height="420" width="327" style="image-rendering:-moz-crisp-edges;">
    </div>
    <div class="product-info">
      <div class="product-text">
        <h1>{{ product.name }}</h1>
        <h2 style="margin-left: 35px;">Available Items <span>{{ product.items }}</span></h2>
        <p>{{ product.description }}</p>
      </div>
      <div class="d-flex flex-row">
        <p><span class="btn-update">{{ product.price }}</span>$</p>

        <a class="btn btn-outline-primary btn-update" href="{%url 'my_app:update_product' product.id%}">Update</a>
        <a class="delete btn btn-outline-danger btn-delete" href="{%url 'my_app:delete_product' product.id%}">Delete</a>

      </div>
    </div>
  </div>


<script>
  $(function asa(){
    $(".delete").click(function(){
        swal({   
            title: "Are you sure?",   
            text: "You will not be able to recover this imaginary file!",   
            type: "warning",   
            showCancelButton: true,   
            confirmButtonColor: "#DD6B55",   
            confirmButtonText: "Yes, delete it!",   
            closeOnConfirm: false 
        }).then(isConfirmed => { 
          if(isConfirmed) {
            $(".file").addClass("isDeleted");
            swal("Deleted!", "Your imaginary file has been deleted.", "success"); 
  }
          });
    });
  });
</script>

{% endblock %}

depozit/my_app/templates/my_app/products.html
{% extends 'base.html' %}
{% block content %}

<a  class="btn btn-outline-primary button_add" href="{%url 'my_app:add_product'%}">Add Product</a>

{% if products %}
<div class="container mt-5 mb-5">
    <div class="d-flex justify-content-center row">
        <div class="col-md-10">
        {% for product in products %}
            <div class="row p-2 bg-white border rounded">
                <div class="col-md-1 "><img class="img-fluid img-responsive rounded product-image" src="{{ product.product_pic.url }}"></div>
                <div class="col-md-6 mt-1">
                    <h1>{{ product.name }}</h1>
                    <div class="d-flex flex-row">
                        <p class="text-success">Available items: {{ product.items }} </p>
                    </div>
                    <p class="text-justify text-truncate para mb-0">{{ product.description }}<br><br></p>
                </div>
                <div class="align-items-center align-content-center col-md-3 border-left mt-1">
                    <div class="d-flex flex-row align-items-center">
                        <h2 class="mr-1">${{ product.price }}</h2>
                    </div>
                    <h3 class="text-success">Free shipping</h3>
                    <div class="d-flex flex-column mt-4">

                        <a class="btn btn-primary btn-sm" href="{%url 'my_app:update_product' product.id%}">Modify</a>
                    </div>
                </div>
            </div>
        {% endfor %}
    </div>
  </div>
</div>
{% else %}
    <p>No Products.</p>
{% endif %}





            


















{% endblock %}

depozit/my_app/templates/my_app/products_of_category.html
{% extends 'categorys.html' %}
{% block products %}
{% load static %}

<a  class="button_add" href="{%url 'my_app:add_product' current_category %}">
    <img src="{% static 'img/add.png' %}" alt="Add button" class="account_image" />
</a>  
{% if products_of_category %}
<div class="container mt-5 mb-5">
    <div class="d-flex justify-content-center row">
        <div class="col-md-10">
        {% for product in products_of_category %}
            <div class="row p-2 bg-white border rounded">
                <div class="col-md-3 mt-1"><img class="img-fluid img-responsive rounded product-image" src="{{ product.product_pic.url }}"></div>
                <div class="col-md-6 mt-1">
                    <h1>{{ product.name }}</h1>
                    <div class="d-flex flex-row">
                        <p class="text-success">Available items: {{ product.items }} </p>
                    </div>
                    <p class="text-justify text-truncate para mb-0">{{ product.description }}<br><br></p>
                </div>
                <div class="align-items-center align-content-center col-md-3 border-left mt-1">
                    <div class="d-flex flex-row align-items-center">
                        <h2 class="mr-1">${{ product.price }}</h2>
                    </div>
                    <h3 class="text-success">Free shipping</h3>
                    <div class="d-flex flex-column mt-4">

                        <a class="btn btn-primary btn-sm" href="{%url 'my_app:update_product' product.id%}">Modify</a>
                    </div>
                </div>
            </div>
        {% endfor %}
    </div>
  </div>
</div>
{% else %}
    <p>No Products.</p>
{% endif %}
{% endblock %}